Leetcode.1160.拼写单词

题目

给你一份『词汇表』(字符串数组) words 和一张『字母表』(字符串) chars。

假如你可以用 chars 中的『字母』(字符)拼写出 words 中的某个『单词』(字符串),那么我们就认为你掌握了这个单词。

注意:每次拼写时,chars 中的每个字母都只能用一次。

返回词汇表 words 中你掌握的所有单词的 长度之和。

 

示例 1:

输入:words = ["cat","bt","hat","tree"], chars = "atach"
输出:6
解释: 
可以形成字符串 "cat" 和 "hat",所以答案是 3 + 3 = 6。
示例 2:

输入:words = ["hello","world","leetcode"], chars = "welldonehoneyr"
输出:10
解释:
可以形成字符串 "hello" 和 "world",所以答案是 5 + 5 = 10。

思路

想到了用哈希表 c 记录字母表中字母以及相应频数,再用另外一个哈希表 w 记录words中单词的相应字母以及频数,w 中所有字母必须为 c 中的字母的子集并且相应字母频数不能超过时,words中的单词才可以用 chars 表示。改进:在评论区看到可以用数组记录的方法,会比哈希表更快,但是思路相同。实现如下:

class Solution {
public:
    int countCharacters(vector<string>& words, string chars) {
        if(words.empty()||chars.empty())
            return 0;

        unordered_map<char, int> c;
        for(int i=0 ; i<chars.size(); i++){
            char t=chars[i];
            c.find(t)==c.end()?c[t]=1:c[t]++;
        }

        int ans=0;
        for(int i=0; i<words.size(); i++){
            unordered_map<char, int> w;
            int j=0;
            for(; j<words[i].size(); j++){
                char t=words[i][j];
                if(c.find(t)==c.end())
                    break;
                w.find(t)==w.end()?w[t]=1:w[t]++;
                if(w[t]>c[t])
                    break;
            }
            if(j==words[i].size())
                ans+=words[i].size();
        }
        return ans;
    }
};

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值